<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="cs">
<head>
<!-- Generated by javadoc (11.0.15) on Tue May 17 12:38:10 CEST 2022 -->
<title>Car</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2022-05-17">
<link rel="stylesheet" type="text/css" href="../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../script.js"></script>
<script type="text/javascript" src="../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="Car";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">cvut.fel</a></div>
<h2 title="Class Car" class="title">Class Car</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>cvut.fel.Car</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">Car</span>
extends java.lang.Object</pre>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(double,double,double,double,double)">Car</a></span>&#8203;(double&nbsp;x,
   double&nbsp;y,
   double&nbsp;width,
   double&nbsp;height,
   double&nbsp;speed)</code></th>
<td class="colLast">
<div class="block">Constructs an instance of a Car.</div>
</td>
</tr>
<tr class="rowColor">
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E(double,double,double,double,double,double,double,double,double,double,double,int%5B%5D,java.lang.String)">Car</a></span>&#8203;(double&nbsp;x,
   double&nbsp;y,
   double&nbsp;speed,
   double&nbsp;acceleration,
   double&nbsp;maxAcceleration,
   double&nbsp;maxSpeed,
   double&nbsp;s0,
   double&nbsp;T,
   double&nbsp;maxDeceleration,
   double&nbsp;width,
   double&nbsp;height,
   int[]&nbsp;lanes,
   java.lang.String&nbsp;skin)</code></th>
<td class="colLast">
<div class="block">Constructs an instance of a Car.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#advance(cvut.fel.Car,double,java.util.ArrayList,java.util.ArrayList)">advance</a></span>&#8203;(<a href="Car.html" title="class in cvut.fel">Car</a>&nbsp;targetCar,
       double&nbsp;dt,
       java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;ProbabilityList,
       java.util.ArrayList&lt;<a href="Car.html" title="class in cvut.fel">Car</a>&gt;&nbsp;cars)</code></th>
<td class="colLast">
<div class="block">Implementation of the Intelligent Driver's Model.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected boolean</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#decideToChangeLane(java.util.ArrayList)">decideToChangeLane</a></span>&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;list)</code></th>
<td class="colLast">
<div class="block">Argument is the Probability list from class Model</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>javafx.geometry.BoundingBox</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getBBox()">getBBox</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getHeight()">getHeight</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getIdxOfCurrLane(double)">getIdxOfCurrLane</a></span>&#8203;(double&nbsp;lane)</code></th>
<td class="colLast">
<div class="block">Returns index of the current lane based on current lane</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>javafx.scene.image.Image</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSkin()">getSkin</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getSpeed()">getSpeed</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getWidth()">getWidth</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getX()">getX</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getY()">getY</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code>protected int</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#chooseLaneIdx()">chooseLaneIdx</a></span>()</code></th>
<td class="colLast">
<div class="block">Selects and adjacent lane index baseed on the current one</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code>protected void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#moveCarToLane(int)">moveCarToLane</a></span>&#8203;(int&nbsp;laneIdx)</code></th>
<td class="colLast">
<div class="block">Sets Y position based on the argument</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#moveToStart()">moveToStart</a></span>()</code></th>
<td class="colLast">
<div class="block">Sets current X position so that the car is moved to the beginning of the scene</div>
</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setX(double)">setX</a></span>&#8203;(double&nbsp;x)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setY(double)">setY</a></span>&#8203;(double&nbsp;y)</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code>javafx.geometry.BoundingBox</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#updateBBox(double,double,double,double)">updateBBox</a></span>&#8203;(double&nbsp;x,
          double&nbsp;y,
          double&nbsp;width,
          double&nbsp;height)</code></th>
<td class="colLast">
<div class="block">Updates bounding box of the car based on given arguments</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;(double,double,double,double,double,double,double,double,double,double,double,int[],java.lang.String)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>Car</h4>
<pre>public&nbsp;Car&#8203;(double&nbsp;x,
           double&nbsp;y,
           double&nbsp;speed,
           double&nbsp;acceleration,
           double&nbsp;maxAcceleration,
           double&nbsp;maxSpeed,
           double&nbsp;s0,
           double&nbsp;T,
           double&nbsp;maxDeceleration,
           double&nbsp;width,
           double&nbsp;height,
           int[]&nbsp;lanes,
           java.lang.String&nbsp;skin)</pre>
<div class="block">Constructs an instance of a Car.
 This particular instance is used to create a vehicle, not a roadblock!</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>x</code> - X pixel position of the car</dd>
<dd><code>y</code> - Y pixel position of the car</dd>
<dd><code>speed</code> - number of pixels to determine the upcoming X position of the car</dd>
<dd><code>acceleration</code> - number of pixels to determine the change of speed</dd>
<dd><code>maxAcceleration</code> - number which specifies the maximum value of acceleration</dd>
<dd><code>maxSpeed</code> - number which specifies the maximum value of speed</dd>
<dd><code>s0</code> - number of pixels to specify minimum gap between the car and and object in front</dd>
<dd><code>T</code> - reaction time of the car, used in the IDM equation</dd>
<dd><code>maxDeceleration</code> - number which specifies the maximum value of deceleration</dd>
<dd><code>width</code> - number to specify width of image of the car in pixels</dd>
<dd><code>height</code> - number to specify height of image of the car in pixels</dd>
<dd><code>lanes</code> - list of all lanes on the road where the car is at</dd>
<dd><code>skin</code> - image of the car, argument is the URL of the image</dd>
</dl>
</li>
</ul>
<a id="&lt;init&gt;(double,double,double,double,double)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>Car</h4>
<pre>public&nbsp;Car&#8203;(double&nbsp;x,
           double&nbsp;y,
           double&nbsp;width,
           double&nbsp;height,
           double&nbsp;speed)</pre>
<div class="block">Constructs an instance of a Car.
 This particular instance is used to create a ROADBLOCK! not a car</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>x</code> - X pixel position of the roadblock</dd>
<dd><code>y</code> - Y pixel position of the roadblock</dd>
<dd><code>width</code> - number to specify width of image of the roadblock in pixels</dd>
<dd><code>height</code> - number to specify height of image of the roadblock in pixels</dd>
<dd><code>speed</code> - is always 0 for roadblock, important for the IDM equation</dd>
</dl>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="advance(cvut.fel.Car,double,java.util.ArrayList,java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>advance</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;advance&#8203;(<a href="Car.html" title="class in cvut.fel">Car</a>&nbsp;targetCar,
                    double&nbsp;dt,
                    java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;ProbabilityList,
                    java.util.ArrayList&lt;<a href="Car.html" title="class in cvut.fel">Car</a>&gt;&nbsp;cars)</pre>
<div class="block">Implementation of the Intelligent Driver's Model.
 Calculates acceleration to be changed in the next step.
 Majority of this method is based on <a href="https://towardsdatascience.com/simulating-traffic-flow-in-python-ee1eab4dd20f">this article</a>
 Please see <a href="https://traffic-simulation.de/info/info_IDM.html">this link</a>
 or <a href="https://en.wikipedia.org/wiki/Intelligent_driver_model">Wikipedia</a>
 for more detailed information about the IDM.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>targetCar</code> - can either be a car in front of the current car</dd>
<dd><code>dt</code> - time step, the right value was achieved through trial and error</dd>
<dd><code>ProbabilityList</code> - list of 0s and 1s, their ration is based on Model, needed to determin whether the car changes lane or not</dd>
<dd><code>cars</code> - list of all objects on the road, needed for lane change</dd>
</dl>
</li>
</ul>
<a id="updateBBox(double,double,double,double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>updateBBox</h4>
<pre class="methodSignature">public&nbsp;javafx.geometry.BoundingBox&nbsp;updateBBox&#8203;(double&nbsp;x,
                                              double&nbsp;y,
                                              double&nbsp;width,
                                              double&nbsp;height)</pre>
<div class="block">Updates bounding box of the car based on given arguments</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>x</code> - X position</dd>
<dd><code>y</code> - Y position</dd>
<dd><code>width</code> - width in pixels</dd>
<dd><code>height</code> - height in pixels</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>updated Bounding box</dd>
</dl>
</li>
</ul>
<a id="moveCarToLane(int)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>moveCarToLane</h4>
<pre class="methodSignature">protected&nbsp;void&nbsp;moveCarToLane&#8203;(int&nbsp;laneIdx)</pre>
<div class="block">Sets Y position based on the argument</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>laneIdx</code> - index of the desired lane in the lanes list</dd>
</dl>
</li>
</ul>
<a id="moveToStart()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>moveToStart</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;moveToStart()</pre>
<div class="block">Sets current X position so that the car is moved to the beginning of the scene</div>
</li>
</ul>
<a id="decideToChangeLane(java.util.ArrayList)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>decideToChangeLane</h4>
<pre class="methodSignature">protected&nbsp;boolean&nbsp;decideToChangeLane&#8203;(java.util.ArrayList&lt;java.lang.Integer&gt;&nbsp;list)</pre>
<div class="block">Argument is the Probability list from class Model</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>list</code> - list of 0s and 1s, their ration is based on Model, needed to determin whether the car changes lane or not</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>true if the randomly selected number is 1, false if the number is 0</dd>
</dl>
</li>
</ul>
<a id="chooseLaneIdx()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>chooseLaneIdx</h4>
<pre class="methodSignature">protected&nbsp;int&nbsp;chooseLaneIdx()</pre>
<div class="block">Selects and adjacent lane index baseed on the current one</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>index of the adjacent lane</dd>
</dl>
</li>
</ul>
<a id="getIdxOfCurrLane(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getIdxOfCurrLane</h4>
<pre class="methodSignature">protected&nbsp;int&nbsp;getIdxOfCurrLane&#8203;(double&nbsp;lane)</pre>
<div class="block">Returns index of the current lane based on current lane</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>lane</code> - current lane</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>index of current lane</dd>
</dl>
</li>
</ul>
<a id="getSkin()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSkin</h4>
<pre class="methodSignature">public&nbsp;javafx.scene.image.Image&nbsp;getSkin()</pre>
</li>
</ul>
<a id="getX()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getX</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getX()</pre>
</li>
</ul>
<a id="getY()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getY</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getY()</pre>
</li>
</ul>
<a id="setX(double)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setX</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setX&#8203;(double&nbsp;x)</pre>
</li>
</ul>
<a id="getWidth()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getWidth</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getWidth()</pre>
</li>
</ul>
<a id="getHeight()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getHeight</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getHeight()</pre>
</li>
</ul>
<a id="getSpeed()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSpeed</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;getSpeed()</pre>
</li>
</ul>
<a id="getBBox()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getBBox</h4>
<pre class="methodSignature">public&nbsp;javafx.geometry.BoundingBox&nbsp;getBBox()</pre>
</li>
</ul>
<a id="setY(double)">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>setY</h4>
<pre class="methodSignature">public&nbsp;void&nbsp;setY&#8203;(double&nbsp;y)</pre>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../index-files/index-1.html">Index</a></li>
<li><a href="../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
</footer>
</body>
</html>
